'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = composeReducers;

var _lodash = require('lodash');

var _createReducer = require('./createReducer');

var _createReducer2 = _interopRequireDefault(_createReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function composeReducers() {
  for (var _len = arguments.length, reducers = Array(_len), _key = 0; _key < _len; _key++) {
    reducers[_key] = arguments[_key];
  }

  reducers = (0, _lodash.compact)(reducers);

  if (reducers.length === 0) return _lodash.identity;
  if (reducers.length === 1) return reducers[0];

  // if all reducers have actionHandlers maps, merge the maps using composeReducers
  if ((0, _lodash.every)(reducers, function (reducer) {
    return reducer.actionHandlers instanceof Object;
  })) {
    var _ret = function () {
      var actionHandlers = {};
      var initialState = void 0;
      reducers.forEach(function (reducer) {
        if (initialState === undefined) initialState = reducer.initialState;
        (0, _lodash.forEach)(reducer.actionHandlers, function (actionHandler, type) {
          (actionHandlers[type] || (actionHandlers[type] = [])).push(actionHandler);
        });
      });
      return {
        v: (0, _createReducer2.default)(initialState, (0, _lodash.mapValues)(actionHandlers, function (typeHandlers) {
          return composeReducers.apply(undefined, _toConsumableArray(typeHandlers));
        }))
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }

  return function (state, action) {
    return (0, _lodash.reduce)(reducers, function (state, reducer) {
      return reducer(state, action);
    }, state);
  };
}