"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;
function createMiddleware(actionHandlers) {
  var result = function result(store) {
    return function (next) {
      return function (action) {
        var handler = actionHandlers[action.type];
        return handler ? handler(store)(next)(action) : next(action);
      };
    };
  };
  result.actionHandlers = actionHandlers;
  return result;
}