"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createPluggableMiddleware;
/**
 * This is used for hot reloading redux middleware.
 *
 * let hmrMiddleware = createPluggableMiddleware(myMiddleware);
 * // hmrMiddleware can be used with applyMiddleware() just like anything else.
 * // but later if you need to replace it you can do:
 * hmrMiddleware.replaceMiddleware(myNewMiddleware);
 */
function createPluggableMiddleware(middleware) {
  var result = function result(store) {
    return function (next) {
      return function (action) {
        if (middleware) {
          return middleware(store)(next)(action);
        }
        return next(action);
      };
    };
  };
  result.replaceMiddleware = function (nextMiddleware) {
    return middleware = nextMiddleware;
  };
  return result;
}