'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReducer;

var _lodash = require('lodash');

function createReducer(initialState, actionHandlers) {
  if (arguments.length === 1) {
    actionHandlers = initialState;
    initialState = undefined;
  }

  var result = void 0;
  if ((0, _lodash.keys)(actionHandlers).length) {
    result = function result() {
      var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
      var action = arguments[1];

      var reducer = actionHandlers[action.type];
      return reducer ? reducer(state, action) : state;
    };
  } else {
    result = function result() {
      var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
      return state;
    };
  }
  result.initialState = initialState;
  result.actionHandlers = actionHandlers;
  return result;
}